#include "CRC.h"
#include "DS1822.h"

extern unsigned char DS1822_SERIAL_NUMBER[MAX_SENSORS][DS1822_SERIAL_NUM_SIZE];

unsigned char Crc8Dallas(unsigned char len, char sens_num)
{
 	unsigned char crc = 0;
 	unsigned char i;
	unsigned char cnt=0;

 	while (len--)
 	{
 		crc ^= DS1822_SERIAL_NUMBER[sens_num][cnt];
		for (i = 0; i < 8; i++)	crc = crc & 0x01 ? (crc >> 1) ^ 0x8C : crc >> 1;
		cnt++;
 	}
	return crc;
}

unsigned char Crc8Dallas2(unsigned char len, unsigned char *pcBlock)
{
 	unsigned char crc = 0;
 	unsigned char i;

 	while (len--)
 	{
 		crc ^= *pcBlock++;
		for (i = 0; i < 8; i++)
 		crc = crc & 0x01 ? (crc >> 1) ^ 0x8C : crc >> 1;
 	}
	return crc;
}

unsigned char Crc8(unsigned int len, unsigned char *pcBlock)
{
	unsigned char crc = 0xFF;
 	unsigned int i;

 	while (len--)
 	{
 		crc ^= *pcBlock++;
		for (i = 0; i < 8; i++)
 		crc = crc & 0x80 ? (crc << 1) ^ 0x31 : crc << 1;
 	}
 	return crc;
}
